#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>
#include <cstrike>
#include <fun>
	
#define MAX_HP 150
#define MAX_JUMPS 8
#define MONEY 1000

new cv_hp_say_one, cv_hp_say_two, cv_hp_slap, cv_hp_jump

public plugin_init()
{
	register_plugin("Ukraine", "1.0", "404")
	
	cv_hp_say_one = register_cvar("ua_hp_say_one", "8")
	cv_hp_say_two = register_cvar("ua_hp_say_two", "12")
	cv_hp_slap = register_cvar("ua_hp_slap", "50")
	cv_hp_jump = register_cvar("ua_hp_jump", "5")
	
	register_clcmd("say", "clcmdSay")
	
	RegisterHam(Ham_Player_Jump, "player", "ham_PlayerJumpPost", 0)
	RegisterHam(Ham_Player_Duck, "player", "ham_PlayerDuckPost", 0)
	
	RegisterHam(Ham_Spawn, "player", "fwHamPlayerSpawnPost", 1)  
	
	register_event("HLTV", "eNR", "a", "1=0", "2=0")
}

new bool:g_user_say_one[33]
new bool:g_user_say_two[33]
new bool:g_user_jumping[33]// = {true, ...}
new g_user_jumps[33]

static null_stat(id)
{
	g_user_say_one[id] = false
	g_user_say_two[id] = false
	g_user_jumping[id] = false
	g_user_jumps[id] = 0
}

public fwHamPlayerSpawnPost(id)
{
	null_stat(id)
}

public client_disconnect(id)
{
	null_stat(id)
}

public add_hp(id, hp_add)
{
	new hp = get_user_health(id)
	if(hp + hp_add > MAX_HP)
	{
		set_user_health(id, MAX_HP)
	} else {
		set_user_health(id, hp + hp_add)
	}
}

public ham_PlayerDuckPost(id)
{
	if(g_user_jumping[id] && (pev(id, pev_flags) & FL_ONGROUND))
	{
		g_user_jumps[id] = MAX_JUMPS
	}
}

public ham_PlayerJumpPost(id)
{
	if((pev(id, pev_flags) & FL_ONGROUND) && !(pev(id, pev_oldbuttons) & IN_JUMP))
	{
		if(g_user_jumping[id])
		{
			g_user_jumps[id]++
			if(g_user_jumps[id] < MAX_JUMPS)
			{
				add_hp(id, get_pcvar_num(cv_hp_jump))
			} else {
				g_user_jumping[id] = false
			}
		}
	}
}

public clcmdSay(id)
{
	if(is_user_alive(id))
	{
		new chat[192]
		read_args(chat, 191)
		remove_quotes(chat)
		
		new u_money
		if(equali(chat, "Слава Украине!") || equali(chat, "Слава Украине! Героям слава!") || equali(chat, "Кто не скачет, тот москаль!")) {
			g_user_say_one[id] = true
			g_user_say_two[id] = true
			g_user_jumps[id] = MAX_JUMPS
			
			if(random_num(0, 2) == 0)
			{
				user_slap(id, get_pcvar_num(cv_hp_slap))
				client_print(id, print_chat, "Ви були поранені за мову окупантів!")
			} else {
				u_money = cs_get_user_money(id)
				if(u_money < MONEY)
				{
					cs_set_user_money(id, 0, 1)
				} else {
					cs_set_user_money(id, u_money - MONEY, 1)
				}
				client_print(id, print_chat, "Ви були оштрафовані за мову окупантів!")
			}
		} else if(equali(chat, "Слава Україні!") && g_user_say_one[id] == false) {
			add_hp(id, get_pcvar_num(cv_hp_say_one))
			g_user_say_one[id] = true
		} else if(equali(chat, "Слава Україні! Героям слава!") && g_user_say_two[id] == false) {
			add_hp(id, get_pcvar_num(cv_hp_say_two))
			g_user_say_two[id] = true
		} else if(equali(chat, "Хто не скаче, той москаль!") && g_user_jumping[id] == false) {
			g_user_jumping[id] = true
		} else if(equali(chat, "565") || equali(chat, "SMS")) {
			u_money = cs_get_user_money(id)
			if(u_money < MONEY)
			{
				client_print(id, print_chat, "Недостатньо коштів для пожертвування!")
				return PLUGIN_HANDLED
			} else {
				cs_set_user_money(id, cs_get_user_money(id) - MONEY, 1)
				new name[32]
				get_user_name(id, name, charsmax(name))
				if(random_num(0, 9) == 0)
				{
					cs_set_user_armor(id, 100, CS_ARMOR_VESTHELM)
					client_print(0, print_chat, "%s підтримав армію України і отримав бронежелети! ", name)
				} else {
					client_print(0, print_chat, "%s підтримав армію України!", name)
				}
			}
		}
	}
	return PLUGIN_CONTINUE
}